package xyz.ottr.lutra.revottr.evaluation;

/*-
 * #%L
 * xyz.ottr.lutra:lutra-revottr
 * %%
 * Copyright (C) 2018 - 2023 University of Oslo
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-2.1.html>.
 * #L%
 */

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.vocabulary.RDF;
import xyz.ottr.lutra.OTTR;
import xyz.ottr.lutra.TemplateManager;
import xyz.ottr.lutra.api.StandardTemplateManager;
import xyz.ottr.lutra.model.Argument;
import xyz.ottr.lutra.model.Instance;
import xyz.ottr.lutra.model.ListExpander;
import xyz.ottr.lutra.model.Parameter;
import xyz.ottr.lutra.model.Template;
import xyz.ottr.lutra.model.terms.ListTerm;
import xyz.ottr.lutra.model.terms.NoneTerm;
import xyz.ottr.lutra.model.terms.Term;
import xyz.ottr.lutra.revottr.model.Mapping;
import xyz.ottr.lutra.revottr.model.Mappings;
import xyz.ottr.lutra.revottr.model.PartialOrder;
import xyz.ottr.lutra.revottr.model.terms.Placeholder;
import xyz.ottr.lutra.wottr.parser.WTermParser;

/**
 * Implements the evaluation functions of Reverse OTTR and thus allows evaluating
 * an OTTR template as a query over an RDF graph.
 * <p>
 * This class is intended as the main entry point of the revottr package by
 * instantiating it and calling its evaluateQuery method. Doing so requires a Jena Model,
 * that represents the graph to be queried, a Lutra TemplateManager, that keeps
 * track of template libraries, and a number for the maximum number of repetitions in
 * lists generated by reverse list expansion.
 *
 * @see ListUnexpander
 */
public class Evaluator {

    private Map<String, Set<Mapping>> templateMappings;
    private final TemplateManager templateManager;
    private int maxRepetitions = 0;

    /**
     * Creates an Evaluator for evaluating a template as a query over a graph.
     * Initializes mappings from base template parameters to values in the given
     * model.
     *
     * @param model A Jena Model that represents the graph to be queried over.
     * @param templateManager A TemplateManager that keeps track of templates
     * @param maxRepetitions A natural number for the maximum number of
     *                       repetitions in lists generated by reverse list expansion.
     */
    public Evaluator(Model model, TemplateManager templateManager, int maxRepetitions) {
        this.templateManager = templateManager;
        this.maxRepetitions = maxRepetitions;
        initialiseTemplateMappings(model);
    }

    /**
     * Creates an Evaluator for evaluating a template as a query over a graph.
     * Initializes mappings from base template parameters to values in the given
     * model.
     *
     * @param graphPath Path to RDF graph
     * @param libFormat Format of template library
     * @param libPaths Path to template library
     * @param maxRepetitions Maximum number of repetitions in lists generated
     *                       by reverse list expansion
     */
    public Evaluator(String graphPath, String libFormat, Collection<String> libPaths, int maxRepetitions) {
        this(
                ModelFactory.createDefaultModel().read(graphPath),
                initTemplateManager(libFormat, libPaths),
                maxRepetitions
        );
    }

    private static TemplateManager initTemplateManager(String libFormat, Collection<String> libPaths) {
        TemplateManager templateManager = new StandardTemplateManager();
        templateManager.readLibrary(libFormat, libPaths);
        return templateManager;
    }

    /**
     * Evaluates a template as a query over the model that was used to create the evaluator.
     *
     * @param iri The IRI of a template as a string, to be evaluated as a query.
     * @return A set of mappings, that when evaluated in OTTR as instances of the input IRI,
     * should produce a subset of the input graph used to instantiate the Evaluator-class.
     */
    public Set<Mapping> evaluateQuery(String iri) {
        return getTemplateMapping(iri).stream()
                .filter(this::validIDs)
                .collect(Collectors.toSet());
    }

    /**
     * A mapping has valid IDs if no list ID is repeated in the mapping.
     * The ID of lists from reverse list expansion are ignored.
     */
    private boolean validIDs(Mapping mapping) {
        Set<Long> ids = new HashSet<>();
        for (Term var : mapping.domain()) {
            Term term = mapping.get(var);
            if (term instanceof ListTerm
                    && !PartialOrder.isUnexpanded(term)) {
                long id = ((ListTerm) term).getIdentifier();
                if (ids.contains(id)) {
                    return false;
                } else {
                    ids.add(id);
                }
            }
        }

        return true;
    }

    private Set<Mapping> getTemplateMapping(String iri) {
        if (!this.templateMappings.containsKey(iri)) {
            this.templateMappings.put(iri, evaluateTemplate(iri));
        }
        return this.templateMappings.get(iri);
    }


    private Set<Mapping> evaluateTemplate(String iri) {
        Template template = templateManager.getTemplateStore().getTemplate(iri).get();
        Set<Set<Mapping>> instanceEvaluations = template.getPattern().stream()
                .map(this::evaluateInstance)
                .collect(Collectors.toSet());
        Set<Mapping> bodyEvaluation = Mappings.joinAll(instanceEvaluations);
        List<Parameter> parameters = template.getParameters();
        return processTemplateMapping(bodyEvaluation, parameters);
    }

    /**
     * Filters potential result mappings for a template against parameters of template.
     * Generates additional solutions based on non-optional parameters and
     * default values.
     */
    private Set<Mapping> processTemplateMapping(Set<Mapping> mappings, List<Parameter> parameters) {
        Set<Mapping> filteredAlternatives = new HashSet<>();
        for (Mapping mapping : mappings) {
            if (mapping.conforms(parameters)) {
                Mapping filtered = placeholderFilter(mapping, parameters);
                Set<Mapping> alternatives = filtered.defaultAlternatives(parameters);
                filteredAlternatives.addAll(alternatives);
            }
        }

        Set<Mapping> result = Util.setUnion(filteredAlternatives, nonOptUnfltr(parameters));

        return result.stream()
                .filter(m -> !containsGreater(result, m))
                .collect(Collectors.toSet());
    }

    /**
     * Checks whether a given mapping is less than a mapping in the given set
     * according to the partial order defined in PartialOrder.
     */
    private boolean containsGreater(Set<Mapping> mappings, Mapping mapping) {
        for (Mapping other : mappings) {
            if (!mapping.equals(other) && lessOrEqualMapping(mapping, other)) {
                return true;
            }
        }
        return false;
    }

    /**
     * Checks whether a mapping m1 is less or equal to a mapping m2, for each variable
     * in their domain. Here, it's assumed that m1 and m2 have the same domain.
     * @see PartialOrder#isLessOrEqual(Term, Term)
     */
    private boolean lessOrEqualMapping(Mapping m1, Mapping m2) {
        for (Term var : m1.domain()) {
            if (!PartialOrder.isLessOrEqual(m1.get(var), m2.get(var))) {
                return false;
            }
        }
        return true;
    }

    /**
     * Filters placeholders in a mapping according to modifiers of parameters.
     * It's assumed that the domain of the given mapping is the same as the set
     * of variables of the given parameters.
     * @see PartialOrder#getGLB(Term, Term)
     * @see Placeholder#getCorresponding(Parameter)
     */
    private Mapping placeholderFilter(Mapping mapping, List<Parameter> parameters) {
        Mapping result = new Mapping();
        for (Parameter parameter : parameters) {
            Term var = parameter.getTerm();
            if (mapping.get(var) instanceof Placeholder) {
                result.put(var, PartialOrder.getGLB(mapping.get(var),
                        Placeholder.getCorresponding(parameter)));
            } else {
                result.put(var, mapping.get(var));
            }
        }
        return result;
    }

    /**
     * Generates additional mappings which have ottr:none for non-optional vars
     * and thus are ignored in forward OTTR. These mappings could be anything
     * for other parameters, which is represented with placeholders.
     */
    private Set<Mapping> nonOptUnfltr(List<Parameter> parameters) {
        Set<Mapping> result = new HashSet<>();

        /*
         * Picks a non-optional parameter to map to none.
         * Maps all other parameters to placeholders, taking
         * into consideration other parameter modifiers
         */
        for (Parameter nonOptParam : parameters) {
            if (!nonOptParam.isOptional()) {
                Mapping map = new Mapping();
                map.put(nonOptParam.getTerm(), new NoneTerm());
                for (Parameter parameter : parameters) {
                    if (!parameter.equals(nonOptParam)) {
                        if (parameter.isNonBlank()) {
                            map.put(parameter.getTerm(), Placeholder.anyNonBlank);
                        } else {
                            map.put(parameter.getTerm(), Placeholder.any);
                        }
                    }
                }

                result.add(map);
            }
        }

        return result;
    }

    private Set<Mapping> evaluateInstance(Instance instance) {
        String iri = instance.getIri();

        // Evaluates the template of the instance as a query
        Set<Mapping> templateResult = getTemplateMapping(iri);

        List<Parameter> parameters = templateManager.getTemplateStore()
                .getSignature(iri).get().getParameters();

        // Performs potential reverse list expansion
        if (instance.hasListExpander()) {
            ListUnexpander unexpander =
                    new ListUnexpander(parameters, instance.getArguments(), maxRepetitions);

            if (instance.getListExpander().equals(ListExpander.zipMin)) {
                templateResult = unexpander.unzipMin(templateResult);

            } else if (instance.getListExpander().equals(ListExpander.zipMax)) {
                templateResult = unexpander.unzipMax(templateResult);

            } else {
                // Here it's assumed that the expansion mode is cross.
                // TODO: Check if listexpander is cross, throw error otherwise
                templateResult = unexpander.uncross(templateResult);
            }
        }

        List<Term> paramVars = parameters.stream()
                .map(Parameter::getTerm).collect(Collectors.toList());

        List<Term> argTerms = instance.getArguments().stream()
                .map(Argument::getTerm).collect(Collectors.toList());

        Mapping argMap = new Mapping(paramVars, argTerms);

        // Filters mappings against instance arguments
        return argFilter(templateResult, argMap);
    }

    /**
     * Filters mappings against instance arguments during the evaluation of an OTTR instance.
     * Creates mappings from variables in instance argument to the corresponding values in a
     * given mapping.
     */
    private Set<Mapping> argFilter(Set<Mapping> mappings, Mapping argMap) {
        Set<Mapping> result = new HashSet<>();

        for (Mapping map : mappings) {
            if (Mappings.innerCompatible(map, argMap)) {
                result.add(Mappings.transform(map, argMap));
            }
        }

        return result;
    }

    private void initialiseTemplateMappings(Model model) {
        this.templateMappings = new HashMap<>();

        List<Parameter> tripleParameters = OTTR.BaseTemplate.Triple.getParameters();
        List<Term> tripleVariables = tripleParameters.stream()
                .map(Parameter::getTerm).collect(Collectors.toList());

        List<Parameter> nullableParameters = OTTR.BaseTemplate.Triple.getParameters();
        List<Term> nullableVariables = tripleParameters.stream()
                .map(Parameter::getTerm).collect(Collectors.toList());

        Set<Mapping> triples = new HashSet<>();
        Set<Mapping> nullableTriples = new HashSet<>();

        model.listStatements()
            .filterDrop(stmt -> stmt.getPredicate().equals(RDF.first))
            .filterDrop(stmt -> stmt.getPredicate().equals(RDF.rest))
            .forEach(stmt -> {

                List<Term> tripleList = List.of(
                    WTermParser.toTerm(stmt.getSubject()).get(),
                    WTermParser.toTerm(stmt.getPredicate()).get(),
                    WTermParser.toTerm(stmt.getObject()).get()
                );

                triples.add(new Mapping(tripleVariables, tripleList));
                nullableTriples.add(new Mapping(nullableVariables, tripleList));
            });

        this.templateMappings.put(OTTR.BaseTemplate.Triple.getIri(),
                processTemplateMapping(triples, tripleParameters));
        this.templateMappings.put(OTTR.BaseTemplate.NullableTriple.getIri(),
                processTemplateMapping(nullableTriples, nullableParameters));
    }
}
